using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.SalesOrder.Cqrs;

public record DeleteSalesOrderByIdCommand(string Id) : IRequest<bool>;

public class DeleteSalesOrderByIdHandler : IRequestHandler<DeleteSalesOrderByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteSalesOrderByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteSalesOrderByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.SalesOrder
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.SalesOrder.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}